
   
var gulp = require('gulp'),
sass = require('gulp-sass')(require('sass')),
autoprefixer = require('gulp-autoprefixer'),
rename = require('gulp-rename'),
cssnano = require('gulp-cssnano'),
notify = require('gulp-notify'),
concat = require('gulp-concat'),
uglify = require('gulp-uglify'),
browserSync = require('browser-sync').create(),
path = require('path'),
merge = require('merge-stream'),
fs = require('fs');

var scriptsPath = 'src/scripts';
var scriptsDest = 'assets/js';
function getFolders ( dir ) {
return fs.readdirSync(dir)
	.filter(function (file) {
		return fs.statSync(path.join(dir, file)).isDirectory();
	});
}


gulp.task('sass', function () {

return gulp.src('./src/styles/main.scss')
	.pipe(sass({outputStyle: 'expanded'}).on('error', sass.logError))
	.pipe(autoprefixer('last 2 version'))
	.pipe(gulp.dest('./assets/styles'))
	.pipe(rename({suffix: '.min'}))
	.pipe(cssnano())
	.pipe(gulp.dest('./assets/styles'))
	.pipe(browserSync.stream())
	.pipe(notify( {"message": "SASS task complete"} ));
});

gulp.task('scripts', function () {
var folders = getFolders(scriptsPath);
var tasks = folders.map(function (folder) {
	return gulp.src(path.join(scriptsPath, folder, '/**/*.js'))
		.pipe(concat(folder + '.js'))
		.pipe(gulp.dest(scriptsDest))
		.pipe(uglify())
		.pipe(rename(folder + '.min.js'))
		.pipe(gulp.dest(scriptsDest));
});

var roots = gulp.src(path.join(scriptsPath, '/*.js'))
	.pipe(concat('main.js'))
	.pipe(gulp.dest(scriptsDest))
	.pipe(uglify())
	.pipe(rename({suffix: '.min'}))
	.pipe(gulp.dest(scriptsDest));

return merge(tasks, roots)
	.pipe(notify({ "message": "Scripts task complete" }));
});

gulp.task('watch', function () {
gulp.watch('src/styles/**/*.scss', gulp.series('sass'));
gulp.watch('src/scripts/**/*.js', gulp.series('scripts'));
});

gulp.task('browser-sync', function() {
browserSync.init({
	proxy: "https://[redacted].local"
});
});


gulp.task('default', gulp.parallel('sass', 'scripts', 'watch', 'browser-sync'));